
package info.textgrid._import;

import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlType;
import javax.xml.namespace.QName;


/**
 * <p>Java class for ElementSpec complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="ElementSpec">
 *   &lt;complexContent>
 *     &lt;extension base="{http://textgrid.info/import}NodeRewriteSpec">
 *       &lt;sequence>
 *         &lt;element name="mode" type="{http://textgrid.info/import}ImportMode" minOccurs="0"/>
 *         &lt;element name="required" maxOccurs="unbounded" minOccurs="0">
 *           &lt;complexType>
 *             &lt;complexContent>
 *               &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *                 &lt;attribute name="attribute" use="required" type="{http://www.w3.org/2001/XMLSchema}QName" />
 *                 &lt;attribute name="pattern" type="{http://www.w3.org/2001/XMLSchema}string" />
 *               &lt;/restriction>
 *             &lt;/complexContent>
 *           &lt;/complexType>
 *         &lt;/element>
 *         &lt;element name="attribute" maxOccurs="unbounded" minOccurs="0">
 *           &lt;complexType>
 *             &lt;complexContent>
 *               &lt;extension base="{http://textgrid.info/import}NodeRewriteSpec">
 *               &lt;/extension>
 *             &lt;/complexContent>
 *           &lt;/complexType>
 *         &lt;/element>
 *       &lt;/sequence>
 *     &lt;/extension>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "ElementSpec", propOrder = {
    "mode",
    "required",
    "attribute"
})
public class ElementSpec
    extends NodeRewriteSpec
{

    protected ImportMode mode;
    protected List<ElementSpec.Required> required;
    protected List<ElementSpec.Attribute> attribute;

    /**
     * Gets the value of the mode property.
     * 
     * @return
     *     possible object is
     *     {@link ImportMode }
     *     
     */
    public ImportMode getMode() {
        return mode;
    }

    /**
     * Sets the value of the mode property.
     * 
     * @param value
     *     allowed object is
     *     {@link ImportMode }
     *     
     */
    public void setMode(ImportMode value) {
        this.mode = value;
    }

    /**
     * Gets the value of the required property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the required property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getRequired().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link ElementSpec.Required }
     * 
     * 
     */
    public List<ElementSpec.Required> getRequired() {
        if (required == null) {
            required = new ArrayList<ElementSpec.Required>();
        }
        return this.required;
    }

    /**
     * Gets the value of the attribute property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the attribute property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getAttribute().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link ElementSpec.Attribute }
     * 
     * 
     */
    public List<ElementSpec.Attribute> getAttribute() {
        if (attribute == null) {
            attribute = new ArrayList<ElementSpec.Attribute>();
        }
        return this.attribute;
    }


    /**
     * <p>Java class for anonymous complex type.
     * 
     * <p>The following schema fragment specifies the expected content contained within this class.
     * 
     * <pre>
     * &lt;complexType>
     *   &lt;complexContent>
     *     &lt;extension base="{http://textgrid.info/import}NodeRewriteSpec">
     *     &lt;/extension>
     *   &lt;/complexContent>
     * &lt;/complexType>
     * </pre>
     * 
     * 
     */
    @XmlAccessorType(XmlAccessType.FIELD)
    @XmlType(name = "")
    public static class Attribute
        extends NodeRewriteSpec
    {


    }


    /**
     * <p>Java class for anonymous complex type.
     * 
     * <p>The following schema fragment specifies the expected content contained within this class.
     * 
     * <pre>
     * &lt;complexType>
     *   &lt;complexContent>
     *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
     *       &lt;attribute name="attribute" use="required" type="{http://www.w3.org/2001/XMLSchema}QName" />
     *       &lt;attribute name="pattern" type="{http://www.w3.org/2001/XMLSchema}string" />
     *     &lt;/restriction>
     *   &lt;/complexContent>
     * &lt;/complexType>
     * </pre>
     * 
     * 
     */
    @XmlAccessorType(XmlAccessType.FIELD)
    @XmlType(name = "")
    public static class Required {

        @XmlAttribute(required = true)
        protected QName attribute;
        @XmlAttribute
        protected String pattern;

        /**
         * Gets the value of the attribute property.
         * 
         * @return
         *     possible object is
         *     {@link QName }
         *     
         */
        public QName getAttribute() {
            return attribute;
        }

        /**
         * Sets the value of the attribute property.
         * 
         * @param value
         *     allowed object is
         *     {@link QName }
         *     
         */
        public void setAttribute(QName value) {
            this.attribute = value;
        }

        /**
         * Gets the value of the pattern property.
         * 
         * @return
         *     possible object is
         *     {@link String }
         *     
         */
        public String getPattern() {
            return pattern;
        }

        /**
         * Sets the value of the pattern property.
         * 
         * @param value
         *     allowed object is
         *     {@link String }
         *     
         */
        public void setPattern(String value) {
            this.pattern = value;
        }

    }

}
